/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup ADC
  * @{
  */

/**
  * @addtogroup ADC_InjectSample
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
typedef struct
{
  GPIO_Type *gpio;
  GPIO_PinEnum pin;
  GPIO_AnaAltFuncEnum ana_func;
} ADC_GPIOTypeStruct;

ADC_GPIOTypeStruct adcCHxGPIOMap[]  =
{
  {GPIOA, GPIO_PIN_0, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_1, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_2, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_3, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_4, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_5, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_6, GPIO_ANA_AF_0},
  {GPIOA, GPIO_PIN_7, GPIO_ANA_AF_0},
  {GPIOB, GPIO_PIN_0, GPIO_ANA_AF_0},
  {GPIOB, GPIO_PIN_1, GPIO_ANA_AF_0},
  {GPIOC, GPIO_PIN_0, GPIO_ANA_AF_0},
  {GPIOC, GPIO_PIN_1, GPIO_ANA_AF_0},
  {GPIOC, GPIO_PIN_2, GPIO_ANA_AF_0},
  {GPIOC, GPIO_PIN_3, GPIO_ANA_AF_0},
};
uint8_t adcChannelMap[] = {ADC_Channel_0, ADC_Channel_1, ADC_Channel_2, ADC_Channel_3,
                           ADC_Channel_4, ADC_Channel_5, ADC_Channel_6, ADC_Channel_7,
                           ADC_Channel_8, ADC_Channel_9, ADC_Channel_10, ADC_Channel_11,
                           ADC_Channel_12, ADC_Channel_13, ADC_Channel_TEMP
                          };
GPIO_InitTypeStruct ADC_GPIO_InitStruct;
ADCCOM_InitTypeStruct ADCCOM_InitStruct;
ADCCOM_ChannelStruct ADCCOM_ChannelConfigStruct;
ADC_InitTypeStruct ADC_InitStruct;
ADC_ChannelStruct ADC_ChannelConfigStruct;

/* Private define ------------------------------------------------------------*/
                          
/* Private macro -------------------------------------------------------------*/
                          
/* Private variables ---------------------------------------------------------*/
uint8_t len = 10;
uint32_t adcValue = 0;
uint32_t vol;

/* Private function prototypes -----------------------------------------------*/
void ADC_GPIO_Init(ADC_GPIOTypeStruct *ADC_GPIOStruct);

/* Private functions ---------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);

  /* Uart Init */
  EVAL_ComInit();

  /********************* User Code *********************/
  /* Enable clock */
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_ADC, ENABLE);
  RCC_Lock();

  /* Config ADC channel GPIO */
  for(uint8_t i = 0; i < 14; i++)
  {
    ADC_GPIO_Init(&adcCHxGPIOMap[i]);

    if(i >= 1)
    {
      ADC_ScanChannelConfig(ADC0, i - 1, i);
    }
  }

  /* Config ADC common parameters */
  ADCCOM_StructInit(&ADCCOM_InitStruct);
  ADCCOM_InitStruct.AdcSpeed = 1;
  ADCCOM_InitStruct.Vref = ADC_VREF_AVDD;
  ADCCOM_InitStruct.ClkDiv = ADC_CLK_DIV1;
  ADCCOM_InitStruct.SampleTime0 = ADC_SAMPLE_TIME_16Cycles;
  ADCCOM_InitStruct.SampleTime1 = ADC_SAMPLE_TIME_16Cycles;
  ADCCOM_InitStruct.SampleAccuracy = ADC_Sample_Accuracy_12Bit;
  ADCCOM_Init(&ADCCOM_InitStruct);
  ADCCOM_ChannelStructInit(&ADCCOM_ChannelConfigStruct);

  /* Config all channel */
  for(uint8_t i = 1; i < 14; i++)
  {
    ADCCOM_ChannelConfigStruct.Channel = adcChannelMap[i];
    ADCCOM_ChannelConfigStruct.BufferEnable = ENABLE;
    ADCCOM_ChannelConfigStruct.OversampleEnable = DISABLE;
    ADCCOM_ChannelConfigStruct.SampleTimeSel = ADC_SAMPLE_TIME_SEL0;
    ADCCOM_ChannelConfigStruct.Offset = 0;
    ADCCOM_ChannelConfig(&ADCCOM_ChannelConfigStruct);
    ADC_ChannelStructInit(&ADC_ChannelConfigStruct);
    ADC_ChannelConfigStruct.Channel = adcChannelMap[i];
    ADC_ChannelConfigStruct.DataAlign = ADC_DATA_ALIGN_RIGHT;
    ADC_ChannelConfigStruct.DataSign = ADC_DATA_UNSIGNED;
    ADC_ChannelConfigStruct.AWDEnable = DISABLE;
    ADC_ChannelConfig(ADC0, &ADC_ChannelConfigStruct);
  }

  /* Config ADC0 */
  ADC_InitStruct.TrigMode = ADC_TRIG_SW_SEQ_CONTINUOUS_CONV;
  ADC_InitStruct.ContinueWait = ADC_CONTINUE_WAIT_CYCLE_16;
  ADC_InitStruct.ScanChannelLen = 10;
  ADC_Init(ADC0, &ADC_InitStruct);
  /* Config software trigger channel */
  ADC_SoftwareTrigConfig(ADC0, ADC_Channel_0);
  /* Enable ADC0 */
  ADC_Cmd(ADC0, ENABLE);

  /* Start ADC0 conversion */
  ADC_StartConversion(ADC0);
  /* Config inject channel */
  ADC_InjectChannelConfig(ADC0, ADC_Channel_0);
  /* Start inject */
  ADC_InjectStart(ADC0);

  /* Infinite loop */
  while(1)
  {
    /* Start inject */
    ADC_InjectStart(ADC0);

    while(ADC_GetIntFlagStatus(ADC0, ADC_INT_TYPE_EOI) == RESET);

    adcValue = ADC_GetInjectData(ADC0);

    ADC_ClearIntFlag(ADC0, ADC_INT_TYPE_EOI);

    vol = (adcValue) * 3300 / 4096;
    printf("ADC Get Value = %d mv\n", vol);
    DelayMs(1000);
    EVAL_LedToggle(LED1);
  }
}

/**
  * @brief  This function is ADC GPIO Initt.
  * @param  None
  * @retval None
  */
void ADC_GPIO_Init(ADC_GPIOTypeStruct *ADC_GPIOStruct)
{
  ADC_GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ANALOG;
  ADC_GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  ADC_GPIO_InitStruct.GPIO_OType = GPIO_OTYPE_PP;
  ADC_GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  ADC_GPIO_InitStruct.GPIO_Pin = ADC_GPIOStruct->pin;
  GPIO_Init(ADC_GPIOStruct->gpio, &ADC_GPIO_InitStruct);
  GPIO_AnaAFConfig(ADC_GPIOStruct->gpio, ADC_GPIOStruct->pin, ADC_GPIOStruct->ana_func);
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(EVAL_COM0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE));

  return ch;
}



/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
